# サンプルコードについて

## ディレクトリ構成について

ルートディレクトリには、各 Chapter 番号に対応するディレクトリと tsconfig.json が配置されています。

ルートディレクトリで tsc コマンドを実行すると、tsconfig.json の設定に従い、Chapter 1 から 9 までのコードがコンパイルされ、生成された JavaScript ファイルは /dist ディレクトリに出力されます。

Chapter 10 で開発されるアプリケーションのコードは、/10 ディレクトリ内の /hangman と /kanban ディレクトリにそれぞれ格納されており、各プロジェクト専用の tsconfig.json と package.json が含まれています。プロジェクトの詳細については、各ディレクトリ内の README.md を参照してください。

## ファイル命名規則について

各ディレクトリ内には、本書で青色の囲みで示されるサンプルコードの上部にある番号（例：▶️ 2-1）に対応する名前のファイルが格納されています（例：2-1.ts）。

本書で示されるサンプルコードに特定のファイル名がついている場合は、そのサンプルコード番号のディレクトリの中に、複数の特定の名前がついたファイルを格納しています。例えば、Chapter 8 のコード番号 8-1 と 8-2 にはそれぞれ、calc.ts と main.ts という名前が付けられたファイルが含まれています。これらのファイルは、/8-1_2 というディレクトリにまとめて格納されています。

## ファイル実行方法について

サンプルコードを実行するには、まず TypeScript を JavaScript にコンパイルし、続いて Node.js の node コマンドで実行します。また、「1-2-3 TypeScript ファイルの実行」セクションで紹介される ts-node ライブラリを使用すれば、TypeScript ファイルを直接実行することもできます。これらの実行方法については、「1-2 開発環境の構築」セクションで詳細に説明しています。
